.\" Copyright (c) 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	@(#)pwd_mkdb.8	8.1 (Berkeley) 6/6/93
.\"
.Dd June 6, 1993
.Dt PWD_MKDB 8
.Os
.Sh NAME
.Nm pwd_mkdb
.Nd "generate the password databases"
.Sh SYNOPSIS
.Nm pwd_mkdb
.Op Fl c
.Op Fl p
.Op Fl d Ar directory
.Op Fl u Ar username
.Ar file
.Sh DESCRIPTION
.Nm Pwd_mkdb
creates
.Xr db 3
style secure and insecure databases for the specified file.
These databases are then installed into
.Pa /etc/spwd.db
and
.Pa /etc/pwd.db
respectively.
The file is installed into
.Pa /etc/master.passwd .
The file must be in the correct format (see
.Xr passwd 5 ) .
It is important to note that the format used in this system is
different from the historic Version 7 style format.
.Pp
The options are as follows:
.Bl -tag -width flag
.It Fl c
Check if the password file is in the correct format. Do not
change, add, or remove any files.
.It Fl p
Create a Version 7 style password file and install it into
.Pa /etc/passwd .
.It Fl d Ar directory
Store databases into specified destination directory instead of
.Pa /etc .
.It Fl u Ar username
Only update the record for the specified user.  Utilities that
operate on a single user can use this option to avoid the
overhead of rebuilding the entire database.
.El
.Pp
The two databases differ in that the secure version contains the user's 
encrypted password and the insecure version has an asterisk (``*'')
.Pp
The databases are used by the C library password routines (see
.Xr getpwent 3 ) .
.Pp
.Nm Pwd_mkdb
exits zero on success, non-zero on failure.
.Sh FILES
.Bl -tag -width Pa -compact
.It Pa /etc/pwd.db
The insecure password database file.
.It Pa /etc/pwd.db.tmp
A temporary file.
.It Pa /etc/spwd.db
The secure password database file.
.It Pa /etc/spwd.db.tmp
A temporary file.
.It Pa /etc/master.passwd
The current password file.
.It Pa /etc/passwd
A Version 7 format password file.
.El
.Sh BUGS
Because of the necessity for atomic update of the password files,
.Nm
uses
.Xr rename 2
to install them.
This, however, requires that the file specified on the command line live
on the same file system as the
.Pa /etc
directory.
.Pp
There are the obvious races with multiple people running
.Nm
on different password files at the same time.
The front-ends to 
.Nm pwd_mkdb ,
.Xr chpass 1 ,
.Xr passwd 1
and
.Xr vipw 8 ,
handle the locking necessary to avoid this problem.
.Sh COMPATIBILITY
Previous versions of the system had a program similar to
.Nm pwd_mkdb ,
.Xr mkpasswd 8 ,
which built
.Xr dbm 3
style databases for the password file but depended on the calling programs
to install them.
The program was renamed in order that previous users of the program
not be surprised by the changes in functionality.
.Sh SEE ALSO
.Xr chpass 1 ,
.Xr passwd 1 ,
.Xr db 3 ,
.Xr getpwent 3 ,
.Xr passwd 5 ,
.Xr vipw 8
